# PFotos 1.5 Copyright(C) 2017-2022 Cora Kohlmeier, Frank Hamberg
proc setVars {} {
global pfotoshome datahome thumbdir dataname exiftool exifgui imageviewer DOS tclversion
global biniso binfocallength binfocallength35 binaperture binexposure binflash bintimeslot
global bfs fs tf cbbg bg fg bfg sc warn gap colorscheme bgcolorvalue fgcolorvalue 
global csvsep env_ok
global tf_status tf_start tf_end mintime maxtime max_validtime min_validtime mintimedefault excludenotime timebin_active
global langstring lang wmwidth wmheight start_histogram histsize histcoltab
global excludetypes excludedirs excludedirlist excludetypelist excludefilelist excludefiles
global browserlimit numthumbcolumns
global unknownvalue binlabels maxbinvalue lenslabellength
set datahome ""
set thumbdir ""
set exiftool ""
set exifgui ""
set wmwidth [expr int(0.8*[winfo screenwidth .])]
set wmheight [expr int(0.8*[winfo screenheight .])]
set start_histogram 1
set tf_status 0
set browserlimit 40
set numthumbcolumns 4
set binflash  "yes no"
# Höhe des Histogramms über den Zeitschiebern
set histsize 6
set histcoltab black&white
set mintime [absoluteTime "2500:12:31 23:59:59"]
set maxtime [absoluteTime "1900:01:01 00:00:00"]
set mintimedefault [absoluteTime "1970:01:01 00:00:00"]
set max_validtime $maxtime
set min_validtime $mintime
# numerischer Wert für unbekannte (nicht angegebene numerische Werte -- ISO, aperture,.....)
set unknownvalue 9999999
# Maximalwerte für die numerischen Bins. Alles was darüber ist wird in unknown/undefined sortiert
# Brennweite 35mm: die längste Fotolinse hat 5400mm (Canon bei F/14) also gibt es hier 100000mm
set maxbinvalue(focallength35) 100000
# Brennweite Crop: nehmen wir mal den selben Wert :-)
set maxbinvalue(focallength) 100000
# ISO: Canon hat das ISO-Monster mit ISO 4.560.000 gebaut, also machen wir wir mal das Doppelte
set maxbinvalue(iso) 9120000
# Blende: bei Digitalkameras soll es ein Sigma mit F/45 geben, wir nehmen das mal 128
set maxbinvalue(aperture) 128
# Belichtungszeit (in Sekunden): extreme Langzeitbelichtung mit Image-Stacking und EXIF-Korrektur kann schon mal auf Stunden gehen, also ein Tag
set maxbinvalue(exposure) 87600 

set excludenotime 0
set tf_start $mintime
set tf_end $maxtime
set timebin_active 0
# Maximale anzuzeigende Länge für Objektivbezeichnungen. Ist die Bezeichnung länger, wird der Langtext als Tooltip anzeigt
set lenslabellength 25
set csvsep ";"
set fs 12
set tf 11
set bfs 20
set sc #555555
set warn orange

#default color scheme
set colorscheme grey
#white scheme
set bgcolorvalue(white) #ffffff
set fgcolorvalue(white) #444444
#lightgrey scheme
set bgcolorvalue(lightgrey) #888888
set fgcolorvalue(lightgrey) #222222
#grey scheme
set bgcolorvalue(grey) #444444
set fgcolorvalue(grey) #eeeeee
#dark grey scheme
set bgcolorvalue(darkgrey) #101010
set fgcolorvalue(darkgrey) #666666
#black scheme
set bgcolorvalue(black) #000000
set fgcolorvalue(black) #ffffff
#dark green scheme
set bgcolorvalue(darkgreen) #000a05
set fgcolorvalue(darkgreen) #402000
#dark blue scheme
set bgcolorvalue(darkblue) #00050a
set fgcolorvalue(darkblue) #505000
#custom scheme
set bgcolorvalue(custom) #444444
set fgcolorvalue(custom) #eeeeee
# set background and foreground colors 
set bg $bgcolorvalue($colorscheme)  
set fg $fgcolorvalue($colorscheme)  

# Hier vorläufig die Bins für iso, flash, aperture, focallength35 und exposure definieren.
# Die Bins für camera und lens ergeben sich aus dem Datensatz
set biniso "100 200 400 800 1600 3200 6400 12800 25600 51200 102400 $unknownvalue"
set binaperture  "1 2 2.8 4 5.6 8 11 13 16 22 32 128 $unknownvalue"
set binfocallength35  "16 24 35 50 70 100 150 200 250 300 400 500 600 800 $unknownvalue"
set binfocallength  "10 16 24 35 50 70 100 135 170 200 270 330 400 550 $unknownvalue"
set binexposure  "1/8000 1/2000 1/1000 1/750 1/500 1/200 1/100 1/60 1/30 1/10 $unknownvalue"
#set bintimeslot "00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24"
set bintimeslot "0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23"

#hier erst einmal die statische Labels für die Timeslots setzen
for {set i 0} {$i<=8} {incr i} {
#	set ii "0[expr $i]"
	set  binlabels(daytime,$i) "0[expr $i]:00 - 0[expr $i+1]:00"
}
set  binlabels(daytime,9) "09:00 - 10:00"
for {set i 10} {$i<24} {incr i} {
	set  binlabels(daytime,$i) "[expr $i]:00 - [expr $i+1]:00"
}
#set  binlabels(daytime,24) "24:00 - 01:00"

set excludetypes ""
set excludedirs ""
set excludefiles ""
set excludedirlist 0
set excludetypelist 0
set excludefilelist 0
set env_ok 0
readdefaults

if [file isdirectory $datahome] {
   set thumbdir $datahome/.thumbs
   if {![file isdirectory $thumbdir]} {file mkdir $thumbdir}
}
set bfs [expr $fs+2]; # big font size

if {$fs<11} {
  set gap 1
} else {
  set gap 2
}

# Checkbuttons immer schwarz
set cbbg #000000
# MacOS X-Fehler abfangen. Ab Mojave bzw. Tck/Tk-Version > 8.5 werden die Hintergründe von Buttons immer hell gesetzt, deshalb wird hier für MacOS der Button-Vordergrund auf Schwarz gesetzt
# dies macht in anderen OS die Buttons unlesbar, dashalb nur für MacOS und tclversion >8.5
set bfg $fg
if {$DOS>=2 && $tclversion > 8.5} {set bfg #000000}
 
if [winfo exist .top] {
	.top config -bg $bg;
	.top.tatze config -bg $bg -fg $bfg -font "-size $bfs" 
	.top.extractExifs config -bg $bg -fg $bfg -font "-size $bfs" -text $langstring(extract,$lang)
    .top.openfile config -bg $bg -fg $bfg -font "-size $bfs"  -text $langstring(open,$lang)
    .top.histogram1 config -bg $bg -fg $bfg -font "-size $bfs"  -text $langstring(camslenses,$lang)
    .top.histogram2 config -bg $bg -fg $bfg -font "-size $bfs"  -text $langstring(imagedata,$lang)
    .top.preferences config -bg $bg -fg $bfg -font "-size $bfs"  -text $langstring(preferences,$lang)
    .top.license config -bg $bg -fg $bfg -font "-size $bfs"  -text $langstring(license,$lang)
    .top.help config -bg $bg -fg $bfg -font "-size $bfs"  -text $langstring(help,$lang)
    .top.about config -bg $bg -fg $bfg -font "-size $bfs"  -text $langstring(about,$lang)
    .top.exit config -bg $bg -fg $bfg -font "-size $bfs"  -text $langstring(exit,$lang)

}
# Dynamic Help aus BWidget konfigurieren
DynamicHelp::configure -bg $bg -fg $bfg -font "-size $fs" -padx 20 -pady 5 -justify left
}
