# PFotos 1.5 Copyright(C) 2017-2022 Cora Kohlmeier, Frank Hamberg
proc toolLog {} {
global pfotoshome pfotosversion iconpath datahome dataname home
global DOS
global defaulticonsize
global bg abg fg tf bf fs dfg 
global log
global langstring lang
global lastheight lastwidth
if ![info exist lastheight] {set lastheight 0}
if ![info exist lastwidth] {set lastwidth 0}

if ![winfo exist .lw ] {toplevel .lw}
global w
set w .lw
wm geometry $w "+0+30"
set logwidth [expr 20*$fs]
set logheight 80

if {[winfo screenheight .] <=1024} {set logheight 300}
if {[winfo screenheight .] <=800} {set logheight 200}
if {[winfo screenheight .] <=600} {set logheight 150}
wm title $w "Tiger Graphics PFotos -- ExifTool $langstring(log,$lang)"

wm iconmask $w @$iconpath/tinylogo.pic
wm iconbitmap $w @$iconpath/tinylogo.pic
wm protocol $w WM_DELETE_WINDOW destroy
wm resizable $w 0 0
# Scrollabel Windows erzeugen
ScrolledWindow $w.scrw  -scrollbar both -auto both -size $fs
grid $w.scrw -row 0 -column 0 -sticky news

# Scrollable frame für Exif-Output erzeugen
set sf [ScrollableFrame $w.scrw.sf -bg $bg -height 800 -width [expr 10+140*$fs]]

# Im Fenster registrieren
$w.scrw setwidget $sf
# merken für später
set textfr [$sf getframe] 
# Hier muss in -yscrollcommand "hart" auf .lw.t.scroll verwiesen werden, da die scrollbar erst in der Folgezeit instanziiert wird,
# aber nur wir (die "USER") hier schon wissen können, dass es sie gibt :-)
set log [text $textfr.log -width $logwidth -height $logheight \
	-borderwidth 2 -relief raised -font "-size $fs" -bg $bg -fg $fg]
grid $textfr.log -row 0 -column 0

frame $w.but
grid $w.but -row 1 -column 0 -sticky n
button  $w.but.ok -text {  OK  } -font "-size $fs" -state disabled -command {destroy $w}
grid $w.but.ok -row 1 -column 0 -sticky news 

return $w
}
